package com.educomp.intelftp.context
{
	import com.educomp.intelftp.command.AddProjectCommand;
	import com.educomp.intelftp.command.AddProjectResultCommand;
	import com.educomp.intelftp.command.GetProjectCommand;
	import com.educomp.intelftp.command.GetProjectResultCommand;
	import com.educomp.intelftp.events.AddProjectEvevnt;
	import com.educomp.intelftp.events.AddProjectResultEvevnt;
	import com.educomp.intelftp.events.GetProjectEvent;
	import com.educomp.intelftp.events.GetProjectResultEvent;
	import com.educomp.intelftp.mediator.ApplicationMediator;
	import com.educomp.intelftp.mediator.MainProjectMediator;
	import com.educomp.intelftp.model.AppModel;
	import com.educomp.intelftp.services.IProjectService;
	import com.educomp.intelftp.services.ProjectService;
	import com.educomp.intelftp.view.MainProjectComponent;
	
	import flash.display.DisplayObjectContainer;
	
	import org.robotlegs.mvcs.Context;
	
	public class MainApplicationContext extends Context
	{
		public function MainApplicationContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true)
		{
			super(contextView, autoStartup);
		}
		
		override public function startup():void
		{
			// TODO Auto Generated method stub
			
			mapServices();
			mapCommands();
			mapViews();
			mapModel();
			
			
			super.startup();
		}
		
		private function mapServices():void{
			
			injector.mapSingletonOf(IProjectService,ProjectService);
		}
		
		private function mapModel():void{
			injector.mapSingleton(AppModel);
		}
		
		private function mapCommands():void{
			commandMap.mapEvent(AddProjectEvevnt.ADD_PROJECT,AddProjectCommand);
			commandMap.mapEvent(AddProjectResultEvevnt.SUCESSES,AddProjectResultCommand);
		
			commandMap.mapEvent(AddProjectResultEvevnt.FAIL,AddProjectResultCommand);
			commandMap.mapEvent(GetProjectEvent.GET_PROJECT,GetProjectCommand);
			commandMap.mapEvent(GetProjectResultEvent.GET_PROJECT_RESULT_SUCCESS,GetProjectResultCommand);
			//commandMap.mapEvent(GetProjectResultEvent.GETPROJECT_RESULT_FAIL,GetProjectResultCommand);
		}
		
		private function mapViews():void{
			mediatorMap.mapView(IntelFTPDesktopApp,ApplicationMediator);
			mediatorMap.mapView(MainProjectComponent,MainProjectMediator);
		}
	}
}