package com.educomp.intelftp.mediator
{
	import com.educomp.intelftp.events.ChangeApplicationViewEvent;
	import com.educomp.intelftp.vo.AddProjectResultVO;
	import com.educomp.intelftp.vo.ProjectVO;
	
	import mx.controls.Alert;
	
	import org.robotlegs.mvcs.Mediator;
	
	public class ApplicationMediator extends Mediator
	{
		[Inject]
		public var appView:IntelFTPDesktopApp;
		
		public function ApplicationMediator()
		{
			super();
		}
		
		override public function onRegister():void{
			eventDispatcher.addEventListener(ChangeApplicationViewEvent.CHANGE_VIEW,fnAppChangeHandler);
			super.onRegister();
		}
		
		private function fnAppChangeHandler(e:ChangeApplicationViewEvent):void{
			if(e.resultVO as AddProjectResultVO)
			{
				if(e.resultVO.ResultCode == "0")
				{
					appView.mainProjectComp.AddProjectComp.txtFolderPath.text = "";
					appView.mainProjectComp.AddProjectComp.txtProjectName.text = "";
					appView.mainProjectComp.AddProjectComp.dropDownProject.selectedIndex = -1;
					appView.mainProjectComp.AddProjectComp.dtCreation.selectedDate = new Date();
				}
				
				Alert.show("result message: " + e.resultVO.Status + "result code :" + e.resultVO.ResultCode);
				    
			}
			else if(e.resultVO as ProjectVO){
				appView.mainProjectComp.setCurrentState("GetProject");
				appView.mainProjectComp.getProjectComp.txtProjectName.text = e.resultVO.ProjectName;
				appView.mainProjectComp.getProjectComp.txtProjectFolder.text = e.resultVO.FolderName;
				if(e.resultVO.ProjectStatus == "Y")
					appView.mainProjectComp.getProjectComp.txtProjectStatus.text = 'Active';
				else
					appView.mainProjectComp.getProjectComp.txtProjectStatus.text = 'Inactive';
				
				appView.mainProjectComp.getProjectComp.dtCreated.selectedDate = e.resultVO.CreationDate;
			}
		}
	}
}