package com.educomp.intelftp.services
{
	import com.educomp.intelftp.events.AddProjectResultEvevnt;
	import com.educomp.intelftp.events.GetProjectResultEvent;
	import com.educomp.intelftp.vo.AddProjectResultVO;
	import com.educomp.intelftp.vo.ProjectVO;
	
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.RemoteObject;
	
	import org.robotlegs.mvcs.Actor;
	
	public class ProjectService extends Actor implements IProjectService
	{
		
		private var remoteObject:RemoteObject;
		private static const SERVICE_ENDPOINT:String = "http://localhost:8400/IntelFTPApp/messagebroker/amf";
		public function ProjectService()
		{
			remoteObject = new RemoteObject("projectService");
			remoteObject.endpoint = SERVICE_ENDPOINT;
			
			remoteObject.addProjectDetails.addEventListener(ResultEvent.RESULT,handleAddProjectResult);	
			remoteObject.addProjectDetails.addEventListener(FaultEvent.FAULT, handleAddProjectFault);
			
			remoteObject.getProjectDetails.addEventListener(ResultEvent.RESULT,handleGetProjectResult);
			remoteObject.getProjectDetails.addEventListener(FaultEvent.FAULT,handleGetProjectFault);
			super();
		}
		
		public function addProject(projectVO:ProjectVO):void
		{
			remoteObject.addProjectDetails(projectVO);
		}
		
		public function getProjectByName(projectName:String):void
		{
			remoteObject.getProjectDetails(projectName);
		}
		
		public function getAllprojects():void
		{
		}
	
		private function handleAddProjectResult(event:ResultEvent):void{
			if(event.result as AddProjectResultVO)
			{
				
				var resultVO:AddProjectResultVO = event.result as AddProjectResultVO;
				dispatch(new AddProjectResultEvevnt(AddProjectResultEvevnt.SUCESSES,resultVO));
			}
		}
		
		private function handleAddProjectFault(event:FaultEvent):void
		{
			var resultVO:AddProjectResultVO = new AddProjectResultVO();
			    resultVO.ResultCode = "-1";
				resultVO.Status = event.fault.faultCode + ':  ' + event.fault.faultString + '  ' + event.fault.faultDetail;
				dispatch(new AddProjectResultEvevnt(AddProjectResultEvevnt.FAIL,resultVO));
		}
		
		private function handleGetProjectResult(event:ResultEvent):void{
			var resultVO:ProjectVO = event.result as ProjectVO;
			     dispatch(new GetProjectResultEvent(GetProjectResultEvent.GET_PROJECT_RESULT_SUCCESS,resultVO));
		}
		
		private function handleGetProjectFault(event:FaultEvent):void{
			
		}
	}
}